/**
 SPFLocation.h
 
 Copyright © 2017 Sonitor IPS Holding AS.
 Copyright © 2019 Forkbeard Technologies AS.
 All rights reserved.
 */
#import <Foundation/Foundation.h>
#import <CoreGraphics/CoreGraphics.h>

#import "SPFDevice.h"
#import "SPFTransition.h"
#import "SPFVector3.h"

/**
 Describes the level of resolution
 */
typedef NS_ENUM(NSUInteger, SPFLocationResolution)
{
    /**
     * Unknown Position.
     * All coordinates are NaN.
     */
    SPFLocationResolutionNone = 0,

    /**
     0D resolution (room-level).
     Coordinates always describe center of a location.
     Locations with this resolution do not have velocity.
     */
    SPFLocationResolution0D,
    
    /**
     1D resolution.
     Coordinates are attached to a one-dimensional path in the location. E.g. an aisle, hallway or corridor.
     Locations with this resolution have a variable velocity.
     */
    SPFLocationResolution1D,
    
    /*
     2D resolution.
     Coordinates are relative to the location's origin.
     The height is fixed to that of the center of the location.
     Locations with this resolution have a variable velocity.
     */
    SPFLocationResolution2D
};

/**
 Type to which a position can be relative.
 */
typedef NS_ENUM(NSUInteger, SPFLocationRelativeType)
{
    /**
     * Relative to anchor point.
     */
    RELATIVE_TYPE_ANCHOR,
    
    /**
     * Relative to building.
     */
    RELATIVE_TYPE_BUILDING,
    
    /**
     * Relative to the floor.
     */
    RELATIVE_TYPE_FLOOR,
    
    /**
     * Relative to the location.
     */
    RELATIVE_TYPE_LOCATION
};

/**
 Represents location data generated by the positioning engine.
 */
@interface SPFLocation : NSObject <NSCoding, NSSecureCoding>

#pragma mark Properties

/**
 The unique identifier for the location in which the device is positioned.
 */
@property (readonly, retain) NSString* locationId;

/**
 The name for the location in which the device is positioned.
 */
@property (readonly, retain) NSString* locationName;

/**
 Information about the device the position applies to.
 */
@property (readonly, retain) SPFDevice* device;

/**
 The estimated error in meters of the location estimate.
 */
@property (readonly) SPFVector3* locationError;

/**
 Latitude in degrees.
 
 Defaults to `NaN` when latitude could not be determined.
 E.g. when no anchor point has been set on the Sense Server yet.
 
 If the resolution is `SPFLocationResolutionRoom`, the coordinates will always describe the center of a location.
 If the resolution is `SPFLocationResolution1D`, the coordinates are attached to a one-dimensional path in a location. E.g. an aisle, hallway or corridor.
 */
@property (readonly) CGFloat latitude;

/**
 Longitude in degrees.
 
 Defaults to `NaN` when longitude could not be determined.
 E.g. when no anchor point has been set on the Sense Server yet.
 
 If the resolution is `SPFLocationResolutionRoom`, the coordinates will always describe the center of a location.
 If the resolution is `SPFLocationResolution1D`, the coordinates are attached to a one-dimensional path in a location. E.g. an aisle, hallway or corridor.
 */
@property (readonly) CGFloat longitude;

/**
 Altitude measured in meters above sea-level.
 
 Defaults to `NaN` when altitude could not be determined.
 E.g. when no anchor point has been set on the Sense Server yet.
 
 If the resolution is `SPFLocationResolutionRoom`, the coordinates will always describe the center of a location.
 If the resolution is `SPFLocationResolutionD`, the coordinates are attached to a one-dimensional path in a location. E.g. an aisle, hallway or corridor.
 */
@property (readonly) CGFloat altitude;

/**
 The estimated velocity at which the device is moving in meters per second.
 */
@property (readonly) SPFVector3* velocity;

/**
 The estimated error in meters per second of the velocity estimate.
 */
@property (readonly) SPFVector3* velocityError;

/**
 The logical floor of the building in which the user is located.
 */
@property (readonly) NSInteger floor;

/**
 The time in milliseconds at which this location was determined.
 */
@property (readonly) double timestamp;

/**
 Describes level of resolution for this location.
 
 If the resolution is `SPFLocationResolutionRoom`, the coordinates will always describe the center of a location.
 If the resolution is `SPFLocationResolution1D`, the coordinates are attached to a one-dimensional path in a location. E.g. an aisle, hallway or corridor.
 
 @return Resolution for the location.
 
 @see `SPFLocationResolution`
 */
@property (readonly) SPFLocationResolution resolution;

/**
 Contains details on possible transition between locations.
 If this value is nil no transition has occurred.
 
 @return Possible transition details.
 
 @see `SPFTransition`
 */
@property (readonly) SPFTransition* transition;

/**
 Local coordinate relative to the the location it is in.
 May return nil or a vector with NaN values if the requested coordinate is not available.
 
 @return Local coordinate relative to the the location it is in.
 */
-(SPFVector3*) localCoordinate;

/**
 Local coordinate relative to the given type.
 May return nil or a vector with NaN values if the requested coordinate is not available.
 
 @param relativeTo
    The location type the requested coordinate should be relative to
 
 @return Local coordinate relative to the give type
 
 @see `SPFLocationRelativeType`
 */
-(SPFVector3*) localCoordinateRelativeTo:(SPFLocationRelativeType)relativeTo;

@end
